/*
 * deviced
 *
 * Copyright (c) 2012 - 2013 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __POWER_HANDLE_H__
#define __POWER_HANDLE_H__

#define POWER_OPS_NAME      "power"

#define POWER_POWEROFF      "poweroff"
#define POWER_REBOOT        "reboot"
#define POWER_OFF_POPUP     "pwroff-popup"
#define POWER_EXIT          "exit"

#define POWER_FLAG_POWEROFF     "/run/"POWER_POWEROFF
#define POWER_FLAG_REBOOT       "/run/"POWER_REBOOT
#define POWER_FLAG_EXIT         "/run/deviced-shutdown-exit"

enum poweroff_type {
	POWEROFF_TYPE_INVALID = 0,
	POWEROFF_TYPE_NONE = POWEROFF_TYPE_INVALID,     // compat only
	POWEROFF_TYPE_POPUP,
	POWEROFF_TYPE_POWEROFF,                         /* replaces POWEROFF_TYPE_DIRECT */
	POWEROFF_TYPE_DIRECT = POWEROFF_TYPE_POWEROFF,  // compat only
	POWEROFF_TYPE_REBOOT,
	POWEROFF_TYPE_RESTART = POWEROFF_TYPE_REBOOT,   // compat only
	POWEROFF_TYPE_EXIT,
};

struct power_option {
	enum poweroff_type type;
	char *option;
};

struct poweroff_handle {
	pid_t pid;
	int timeout;
	guint timeout_id;
};

int check_power_flag(void);
void powerdown(void);

#endif /* __POWER_HANDLE_H__ */
